clear all;

%--- DEFINE filename, path and scenario ---
filename = 'Model_matlab_Roaf.xlsx';
path = 'C:\Users\Pieter\Dropbox\School\NTNU\2016-2017\Thesis\Matlab\';

%reads the scneario and makes a char of it. probably a better way to do this ;)  
year = xlsread(filename,'Data','C3');
yrs = xlsread(filename,'Flows','B29:E29');
[~,scenario,~] = xlsread(filename,'Data','D3'); 
yr = ['2015';'2016';'2022';'2030'];
for i=1:size(yr)
    if year == yrs(i)
        yr = yr(i,:);
    end
end
export_filename = char(scenario);
export_filename = [export_filename,'_',yr,'.xlsx'];

%--- XLSREAD --- 
[list_X,list_T,Data_X,Data_T,dest_fr,inhab,amount_fractions,amount_flows,process_category,bio_tr,rest_index,txt_out,txt_KPI,company_level,km,E_tr,E_pr,txt_fuels,txt_pr_E,amount_pr,cal_val,incineration,bio_energy,txt_emission] = read_data(filename);
%
%--- HANDLE DATA ---   make the model structure
[model,sortedtech] = handle_data(list_X,list_T,Data_X,Data_T,amount_fractions,inhab);
%
%--- MFA algoritm ---
[model_adj, output] = MFA_algoritm(model,amount_flows,sortedtech);
%
%--- Energy Layer ---
[energy,output] = Energy(output,km,E_tr,E_pr,amount_flows,txt_fuels,txt_pr_E,amount_pr,cal_val,incineration,bio_energy,bio_tr,process_category);

%%
%--- RUN KPI --- 
[KPI] = indicators( model_adj,process_category,bio_tr,rest_index, amount_fractions,amount_flows,dest_fr,company_level,energy);
%%
%[sensitiv,PI_sens] = sensitivity(path,filename,export_filename,list_X,list_T,Data_X,Data_T,amount_fractions,inhab,amount_flows,process_category,bio_tr,rest_index,dest_fr,KPI,company_level,km,E_tr,E_pr,txt_fuels,txt_pr_E,amount_pr,cal_val,incineration,bio_energy);
%%
%--- EXPORT ---
export(path,export_filename,KPI,output,txt_out,txt_KPI,energy,txt_emission,inhab);

