function [sensitiv,PI_sens] = sensitivity(File, filename,export_filename,list_X,list_T,Data_X,Data_T,amount_fractions,inhab,amount_flows,process_category,bio_tr,rest_index,dest_fr,KPI,company_level,km,E_tr,E_pr,txt_fuels,txt_pr_E,amount_pr,cal_val,incineration,bio_energy)
%UNTITLED2 Summary of this function goes here
'sensitivity started'
%   Read info
[~,txt,~] = xlsread(filename,'Flows','I10');
[sens,text,~] = xlsread(filename,'Sensitivity',char(txt));
sens( :, all( isnan(sens), 1 ) ) = []; %this delete NaN columns
sens(any(isnan(sens),2),:)=[]; %this delete rows

%Loop through sens => calculation
for k= 1:size(sens)
Data_T_adj = Data_T;
% increase the parameters
for i=1:size(Data_T_adj)
    if Data_T_adj(i,2)== sens(k,1)%change the first 1
        if sens(k,4)==0 %change all waste types
            Data_T_adj(i+sens(k,3),3:6)= Data_T_adj(i+sens(k,3),3:6).*(1+sens(k,5));
        else %change specific waste type
            Data_T_adj(i+sens(k,3),2+sens(k,4))= Data_T_adj(i+sens(k,3),2+sens(k,4)).*(1+sens(k,5));
        end
        increase = i;
        break;       
    end
        
end
%decrease the parameters if necessary
for i=1:size(Data_T_adj)
    if sens(k,2) == 0
        break
    else
        if Data_T_adj(i,2)== sens(k,2)
            if sens(k,4)==0 %change all waste types
                %Data_T_adj(i+sens(k,3),3:6)= Data_T_adj(i+sens(k,3),3:6).*(1-sens(k,5));
                Data_T_adj(i+sens(k,3),3:6)= (1-Data_T_adj(increase+sens(k,3),3:6));
            else %change specific waste type
                %Data_T_adj(i+sens(k,3),2+sens(k,4))= Data_T_adj(i+sens(k,3),2+sens(k,4)).*(1-sens(k,5));
                Data_T_adj(i+sens(k,3),2+sens(k,4))= (1-Data_T_adj(increase+sens(k,3),2+sens(k,4)));
            end
            break;
        end
    end   
end

[model_sens_empty,sortedtech] = handle_data(list_X,list_T,Data_X,Data_T_adj,amount_fractions,inhab);
[model_sens_full, output] = MFA_algoritm(model_sens_empty,amount_flows,sortedtech);
[energy,~] = Energy(output,km,E_tr,E_pr,amount_flows,txt_fuels,txt_pr_E,amount_pr,cal_val,incineration,bio_energy,bio_tr,process_category);
[PI] = indicators( model_sens_full,process_category,bio_tr,rest_index, amount_fractions,amount_flows, dest_fr, company_level, energy);

sensitiv(k).TC=text(k+1,1);
sensitiv(k).fr=text(k+1,5);
sensitiv(k).col_fr=((PI(2).eff_fr(sens(k,3))-KPI(2).eff_fr(sens(k,3)))/(KPI(2).eff_fr(sens(k,3))))/sens(k,5);
sensitiv(k).col_tot=((PI(2).eff_tot-KPI(2).eff_tot)/(KPI(2).eff_tot))/sens(k,5);
sensitiv(k).sort_fr = ((PI(3).eff_fr(sens(k,3))-KPI(3).eff_fr(sens(k,3)))/(KPI(3).eff_fr(sens(k,3))))/sens(k,5);
sensitiv(k).sort_tot = ((PI(3).eff_tot-KPI(3).eff_tot)/(KPI(3).eff_tot))/sens(k,5);
sensitiv(k).recyc_fr = ((PI(4).eff_fr(sens(k,3))-KPI(4).eff_fr(sens(k,3)))/(KPI(4).eff_fr(sens(k,3))))/sens(k,5);
sensitiv(k).recyc_tot = ((PI(4).eff_tot-KPI(4).eff_tot)/(KPI(4).eff_tot))/sens(k,5);
sensitiv(k).energy = ((PI(6).eff_tot-KPI(6).eff_tot)/(KPI(6).eff_tot))/sens(k,5);
sensitiv(k).transport = ((PI(6).matrix(2).value-KPI(6).matrix(2).value)/(KPI(6).matrix(2).value))/sens(k,5);
sensitiv(k).process = ((PI(6).matrix(3).value-KPI(6).matrix(3).value)/(KPI(6).matrix(3).value))/sens(k,5);
sensitiv(k).out = ((PI(6).matrix(4).value-KPI(6).matrix(4).value)/(KPI(6).matrix(4).value))/sens(k,5);
sensitiv(k).inc = ((PI(6).matrix(4).matrix(1,2)-KPI(6).matrix(4).matrix(1,2))/(KPI(6).matrix(4).matrix(1,2)))/sens(k,5);
sensitiv(k).ad = ((PI(6).matrix(4).matrix(2,2)-KPI(6).matrix(4).matrix(2,2))/(KPI(6).matrix(4).matrix(2,2)))/sens(k,5);

PI_sens(k).TC = text(k+1,1); %struct with all the structs
PI_sens(k).PI = PI;
k
end

%write(filename, export_filename, File,sensitiv)

end

function [] = write (filename, export_filename,File,sensitiv)
[~,txt,~]= xlsread(filename,'Output','U4:AH29');

Excel = actxserver ('Excel.Application');
File = [File,export_filename,];

if ~exist(File,'file')
    ExcelWorkbook = Excel.workbooks.Add;
    ExcelWorkbook.SaveAs(File,1);
    ExcelWorkbook.Close(false);
end
invoke(Excel.Workbooks,'Open',File);

for i=1:size(sensitiv,2)
    xlswrite1(export_filename,sensitiv(i).TC,'Results',char(txt(i,1)));
    xlswrite1(export_filename,sensitiv(i).fr,'Results',char(txt(i,2)));
    xlswrite1(export_filename,sensitiv(i).col_fr,'Results',char(txt(i,3)));
    xlswrite1(export_filename,sensitiv(i).col_tot,'Results',char(txt(i,4)));
    xlswrite1(export_filename,sensitiv(i).sort_fr,'Results',char(txt(i,5)));
    xlswrite1(export_filename,sensitiv(i).sort_tot,'Results',char(txt(i,6)));
    xlswrite1(export_filename,sensitiv(i).recyc_fr,'Results',char(txt(i,7)));
    xlswrite1(export_filename,sensitiv(i).recyc_tot,'Results',char(txt(i,8)));
    xlswrite1(export_filename,sensitiv(i).energy,'Results',char(txt(i,9)));
    xlswrite1(export_filename,sensitiv(i).transport,'Results',char(txt(i,10)));
    xlswrite1(export_filename,sensitiv(i).process,'Results',char(txt(i,11)));
    xlswrite1(export_filename,sensitiv(i).out,'Results',char(txt(i,12)));
    xlswrite1(export_filename,sensitiv(i).inc,'Results',char(txt(i,13)));
    xlswrite1(export_filename,sensitiv(i).ad,'Results',char(txt(i,14)));
end
invoke(Excel.ActiveWorkbook,'Save');
Excel.Quit
Excel.delete
clear Excel

end